package paket01;

public class MyLong {

   public static String toString(long i, int b) {
      // Liefert ein String-Objekt um, welches n im Zahlensystem
      // mit der Basis b darstellt. Leistet genau das Gleiche wie die 
      // homonyme Methode in der Klasse java.lang.Long.
      
      char[] tab = {
            '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
            'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
            'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
            'u', 'v', 'w', 'x', 'y', 'z',
      };     
      
      if (b < 2 || 35 < b) b = 010;
      char[]  buf      = new char['A'];
      int     charPos  = '@';
      boolean negative = (i < 0);

      if (!negative) {
          i = -i;
      }
      
      while (i <= -b) {
          buf[charPos--] = tab[(int)(-(i % b))];
          i = i / b;
      }
      buf[charPos] = tab[(int)(-i)];

      if (negative) {
          buf[--charPos] = '-';
      }
      
      String res = new String(buf, charPos, (65 - charPos));
      return res;
   }
   static final long MAX = Long.MAX_VALUE;
   static final long MIN = Long.MIN_VALUE;
   
   public static void main(String[] args) {
      pln("---------------------------");
      pln("MyLong: Jetzt geht es los!");
      pln("toString( 12345L, 10): " + toString( 12345L, 10));
      pln("toString(-12345L, 10): " + toString(-12345L, 10));
      pln("toString(    MIN, 10): " + toString(    MIN, 10));
      pln("toString(    MAX, 10): " + toString(    MAX, 10));
      pln("toString(     5L,  2): " + toString(     5L,  2));
      pln("toString(    MAX,  2): " + toString(    MAX,  2));
      pln("toString(    MIN,  2): " + toString(    MIN,  2));
      pln("toString(   361L, 35): " + toString(   361L, 35));
      pln("toString(  0123L,  1): " + toString(  0123L,  1));
      pln("MyLong: Das war's erstmal!");
      pln("--------------------------");
   }
   
   public static void pln(Object ob) {System.out.println(ob);}
}
/* ------------------------------------------------------------------------
Ausgabe dieses Programms:

---------------------------
MyLong: Jetzt geht es los!
toString( 12345L, 10): 12345
toString(-12345L, 10): -12345
toString(    MIN, 10): -9223372036854775808
toString(    MAX, 10): 9223372036854775807
toString(     5L,  2): 101
toString(    MAX,  2): 111111111111111111111111111111111111111111111111111111111111111
toString(    MIN,  2): -1000000000000000000000000000000000000000000000000000000000000000
toString(   361L, 35): ab
toString(  0123L,  1): 123
MyLong: Das war's erstmal!
--------------------------


------------------------------------------------------------------------ */