// Datei ReIter01.java
/* -------------------------------------------------------------------------
Unterprogramme mit gleicher Nr (z.B. iter03 und reku03) sollen exakt das
Gleiche leisten, aber die iter-Unterprogramme sollen iterativ (mit Schleifen)
und die reku-Unterprogramme rekursiv arbeiten.
Versehen Sie alle iter- und reku-Methoden mit guten Anfangskommentaren.
------------------------------------------------------------------------- */
class ReIter01 {
   // ---------------------------------------------------------------------
   static private void schritt01(char char01) {
      // Gibt char01 zur Standardausgabe aus-
      p(char01);
   } // schritt01
   // ---------------------------------------------------------- Aufgabe 01
   static public  void iter01(final int N) {
      // ERGAENZEN SIE HIER einen Anfangskommentar
      for (int i=1; i<=N; i++) {
         schritt01('X');
      }
      pln();
   } // iter01
   // ---------------------------------------------------------- Loesung 01
   static public  void reku01(final int N) {
      // ERSETZEN SIE diesen "unsinnigen" Rumpf
      pln("reku01, unsinniges Ergebnis!");
   } // reku01
   // ---------------------------------------------------------- Aufgabe 02
   static public  void iter02(final int N) {
      // ERGAENZEN SIE HIER einen Anfangskommentar
      int n = N;
      while (n > 0) {
         char ziff = (char) (n%2 + '0');
         schritt01(ziff);
         n = n/2;
      }
      pln();
   } // iter02;
   // ---------------------------------------------------------- Loesung 02
   static public  void reku02(final int N) {
      // ERSETZEN SIE diesen "unsinnigen" Rumpf
      pln("reku02, unsinniges Ergebnis!");
   } // reku02
   // ---------------------------------------------------------- Aufgabe 03
   static public  void reku03(final int N) {
      // ERGAENZEN SIE HIER einen Anfangskommentar
      char ziff = (char) (N%2 + '0'); // "Rechteste" Binaerziffer
      if        (N <  0) {
         schritt01('-');
         reku03(-N);
      } else if (N == 0 || N == 1) {  // Hoechstwertige Ziffer
         schritt01(ziff);
         return;
      } else {
         reku03(N/2);
         schritt01(ziff);
      }
   } // reku03
   // ---------------------------------------------------------- Loesung 03
   static public  void iter03(final int N) {
      // ERSETZEN SIE diesen "unsinnigen" Rumpf
      p("iter03, unsinniges Ergebnis!");
   } // iter03
   // ---------------------------------------------------------- Aufgabe 04
   static public  String reku04(String s) {
      // ERGAENZEN SIE HIER einen Anfangskommentar
      if (s.length() <= 1) {
         return s;
      } else {
         char   letzt     = s.charAt   (   s.length()-1);
         String ohneLetzt = s.substring(0, s.length()-1);
         return letzt + reku04(ohneLetzt);
      }
   } // reku04
   // ---------------------------------------------------------- Loesung 04
   static public  String iter04(String s) {
      // ERSETZEN SIE diesen "unsinnigen" Rumpf
      return "iter04, unsinniges Ergebnis!";
   } // iter04
   // ---------------------------------------------------------- Aufgabe 05
   static public  int reku05(int[] r1, int[] r2) {
      // ERGAENZEN SIE HIER einen Anfangskommentar
      return reku05a(r1, r2, 0);
   }

   static private int reku05a(int[] r1, int[] r2, int index) {
      // ERGAENZEN SIE HIER einen Anfangskommentar
      if (index >= r1.length || index >= r2.length) {
         return r1.length - r2.length;
      } else if (r1[index] != r2[index]) {
         return r1[index] - r2[index];
      } else {
         return reku05a(r1, r2, index+1);
      }
   } // reku05a
   // ---------------------------------------------------------- Loesung 05
   static public  int iter05(int[] r1, int[] r2) {
      // ERSETZEN SIE diesen "unsinnigen" Rumpf
      return -999999999; // unsinniges Ergebnis
   } // iter05
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      pln("ReIter01: Jetzt geht es los!");
      pln("-----------------------------------");

      p  ("A iter01(  5):           "); iter01(  5);
      p  ("A reku01(  5):           "); reku01(  5);
      pln("-----------------------------------");
      p  ("B iter02(  8):           "); iter02(  8);
      p  ("B reku02(  8):           "); reku02(  8);
      p  ("C iter02( 11):           "); iter02( 11);
      p  ("C reku02( 11):           "); reku02( 11);
      p  ("D iter02( 13):           "); iter02( 13);
      p  ("D reku02( 13):           "); reku02( 13);
      p  ("E iter02(128):           "); iter02(128);
      p  ("E reku02(128):           "); reku02(128);
      p  ("F iter02( -3):           "); iter02( -3);
      p  ("F reku02( -3):           "); reku02( -3);
      pln("-----------------------------------");
      p  ("G iter03( 11):           "); iter03( 11); pln();
      p  ("G reku03( 11):           "); reku03( 11); pln();
      p  ("H iter03(-13):           "); iter03(-13); pln();
      p  ("H reku03(-13):           "); reku03(-13); pln();
      p  ("I iter03(128):           "); iter03(128); pln();
      p  ("I reku03(128):           "); reku03(128); pln();
      pln("-----------------------------------");
      pln("J iter04('!anna-otto?'): " + iter04("!anna-otto?"));
      pln("J reku04('!anna-otto?'): " + reku04("!anna-otto?"));
      pln("-----------------------------------");

      int[] ir01 = {17, 32, 25};
      int[] ir02 = {17, 28, 99};
      int[] ir03 = {17, 28, 99, 11};

      pln("K iter05(ir01, ir02):    " + iter05(ir01, ir02));
      pln("K reku05(ir01, ir02):    " + reku05(ir01, ir02));
      pln("L iter05(ir02, ir01):    " + iter05(ir02, ir01));
      pln("L reku05(ir02, ir01):    " + reku05(ir02, ir01));
      pln("M iter05(ir02, ir03):    " + iter05(ir02, ir03));
      pln("M reku05(ir02, ir03):    " + reku05(ir02, ir03));
      pln("N iter05(ir03, ir02):    " + iter05(ir03, ir02));
      pln("N reku05(ir03, ir02):    " + reku05(ir03, ir02));
      pln("O iter05(ir03, ir03):    " + iter05(ir03, ir03));
      pln("O reku05(ir03, ir03):    " + reku05(ir03, ir03));
      pln("-----------------------------------");
      pln("ReIter01: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
   // ---------------------------------------------------------------------
} // class ReIter01
/* ------------------------------------------------------------------------
So soll die Ausgabe des Programms ReIter01 (nach der Vervollstaendigung)
aussehen:

ReIter01: Jetzt geht es los!
-----------------------------------
A iter01(  5):           XXXXX
A reku01(  5):           XXXXX
-----------------------------------
B iter02(  8):           0001
B reku02(  8):           0001
C iter02( 11):           1101
C reku02( 11):           1101
D iter02( 13):           1011
D reku02( 13):           1011
E iter02(128):           00000001
E reku02(128):           00000001
F iter02( -3):
F reku02( -3):
-----------------------------------
G iter03( 11):           1011
G reku03( 11):           1011
H iter03(-13):           -1101
H reku03(-13):           -1101
I iter03(128):           10000000
I reku03(128):           10000000
-----------------------------------
J iter04('!anna-otto?'): ?otto-anna!
J reku04('!anna-otto?'): ?otto-anna!
-----------------------------------
K iter05(ir01, ir02):    4
K reku05(ir01, ir02):    4
L iter05(ir02, ir01):    -4
L reku05(ir02, ir01):    -4
M iter05(ir02, ir03):    -1
M reku05(ir02, ir03):    -1
N iter05(ir03, ir02):    1
N reku05(ir03, ir02):    1
O iter05(ir03, ir03):    0
O reku05(ir03, ir03):    0
-----------------------------------
ReIter01: Das war's erstmal!
------------------------------------------------------------------------ */