// Datei Printf01.java
/* ------------------------------------------------------------------------
Diese Klasse enthaelt Klassenmethoden, die einige Moeglichkeiten des
Java-Befehls format (alias printf) demonstrieren.
Fuer eine Aufgabe des Fachs MB2-PR2.
------------------------------------------------------------------------ */
import java.util.Random;

class Printf01 {
   // ---------------------------------------------------------------------
   static public void gibIntsKompaktAus(int anz) {
      /* ------------------------------------------------------------------
      Gibt folgende Daten passend fuer einen Bildschirm mit 80 Zeichen pro
      Zeile aus:
      Zwei Zeilen mit je 79 Minuszeichen.
      Zwischen diesen Minuszeilen genau anz viele Zufallszahlen vom Typ
      int, 5 Zahlen pro Zeile, lesbar formatiert wie z.B.:  -1.188.957.731

      Beispiel fuer eine Ausgabe dieser Methode:
      -------------------------------------------------------------------------------
       -1.188.957.731  1.018.954.901    -39.088.943  1.295.249.578  1.087.885.590
       -1.829.099.982 -1.680.189.627  1.111.887.674   -833.784.125 -1.621.910.390
         -535.098.017 -1.935.747.844 -1.219.562.352    696.711.130    308.881.275
       -1.366.603.797
      -------------------------------------------------------------------------------
      Hinweis. Zum Test sollte diese Methode auch in einem Dos-Fenster mit
      80 Zeichen pro Zeile aufgerufen werden!
      ------------------------------------------------------------------ */
      final String minus79 = "----------------------------------------" +
                             "---------------------------------------";
      Random rand = new Random();

      // HIER FEHLEN NOCH EIN PAAR BEFEHLE

   } // gibIntsKompaktAus
   // ---------------------------------------------------------------------
   static public void gibDreispaltigAus(String[] sr, int[] ir, float[] fr) {
      /* ------------------------------------------------------------------
      Gibt eine Fehlermeldung aus, wenn die die Reihungen sr, ir und fr
      nicht gleich lang sind. Gibt sonst die Daten der drei Reihungen in
      Form einer dreispaltigen Tabelle aus, z.B. so:

      +----------+----+--------+
      |Katzen    |  12|  123,45|
      |Hunde     |   8|    3,46|
      |Kaninchen | 130|2.734,40|
      |Floehe    |5000|    0,01|
      +----------+----+--------+

      Die Spalten haben die Breiten 10, 4 und 8. Die Methode verlaesst sich
      darauf, dass das ausreicht.
      ------------------------------------------------------------------ */

      // HIER FEHLEN NOCH EIN PAAR BEFEHLE

   } // gibDreispaltigAus
   // ---------------------------------------------------------------------
   static public void gibMoeglichstSchmalAus(int[] ir) {
      /* ------------------------------------------------------------------
      Die Komponenten von ir werden lesbar formatiert ausgegeben, eine Zahl
      pro Zeile, die Einerstellen genau untereinander. Alle Zahlen werden
      "so schmal wie moeglich" formatiert, d.h. nur so breit wie die
      breiteste Zahl in ir es erfordert, wie in den folgenden Beispielen:

      Beispiel 1: Relativ schmale Zahlen (Breite: 4)
        17
      -123
       520
         6

      Beispiel 2: Relativ breite Zahlen (Breite 14)
       1.234.567.890
                  34
      -1.234.567.890
         987.654.321
                 278
      ------------------------------------------------------------------ */

      // HIER FEHLEN NOCH EIN PAAR BEFEHLE

   } // gibMoeglichstSchmalAus
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      printf("Printf01: Jetzt geht es los!%n");

      gibIntsKompaktAus(16);
      gibIntsKompaktAus(19);
      gibIntsKompaktAus(20);

      printf("%n");
      printf("GibDreispaltigAus:%n");

      String[] sr01 = {"Katzen", "Hunde", "Kaninchen", "Floehe"};
      int   [] ir01 = {12, 8, 130, 5000};
      float [] fr01 = {123.45F, 3.4567F, 2734.395F, 0.01F};

      gibDreispaltigAus(sr01, ir01, fr01);

      printf("%n");
      printf("gibMoeglichstSchmalAus:%n");

      int[] ir10 = {17, -123, 520, 6};
      int[] ir11 = {1234567890, 34, -1234567890, 987654321, 234};

      gibMoeglichstSchmalAus(ir10); printf("%n");
      gibMoeglichstSchmalAus(ir11);

      printf("Printf01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Zwei Methoden mit kurzen Namen:
   static void   printf(String f, Object... v) {System.out.printf(f, v);}
   static String format(String f, Object... v) {return String.format(f, v);}
   // ---------------------------------------------------------------------
} // class Printf01
