// Datei Ueb_Printf.java
/* ------------------------------------------------------------------------
Dieses Programm PrintfUeb01 leistet Folgendes:
------------------------------------------------------------------------ */
import javax.swing.JButton;

class UebPrintf {
   // ---------------------------------------------------------------------
   static void ganz01() {
      // Ein paar Ganzzahlen (posL und negL) werden mehrfach mit printf-
      // Befehlen und Formatstrings g01a, g01b, ... ausgegeben. Die
      // Soll-Ausgaben der printf-Befehle sind als Kommentar angegeben.
      // Wie muessen die Formatstrings aussehen, damit diese Soll-Ausgaben
      // entstehen?

      gibLinealAus("ganz01");

      // Ein paar Ganzzahlen:
      long posL = +123456789012L;
      long negL = -123456789012L;

      // Die printf-Befehle (und ihre Soll-Ausgabe als Kommentar):
                          //       1   5   10   15   20   25   30
                          //       |   |    |    |    |    |    |
      printf(g01a, posL); // g01a: 123456789012
      printf(g01a, negL); // g01a: -123456789012
      printf(g01b, posL); // g01b:  123456789012
      printf(g01b, negL); // g01b: -123456789012
      printf(g01c, posL); // g01c:         123456789012
      printf(g01c, negL); // g01c:        -123456789012
      printf(g01d, posL); // g01d: 00000000123456789012
      printf(g01d, negL); // g01d: -0000000123456789012
      printf(g01e, posL); // g01e:        +123456789012
      printf(g01e, negL); // g01e:        -123456789012
      printf(g01f, posL); // g01f:         123456789012
      printf(g01f, negL); // g01f:       (123456789012)
      printf(g01g, posL); // g01g:      123.456.789.012
      printf(g01g, negL); // g01g:     -123.456.789.012
      printf(g01h, posL); // g01h:     +123.456.789.012
      printf(g01h, negL); // g01h:     -123.456.789.012
      printf(g01i, posL); // g01i: 00000123.456.789.012
      printf(g01i, negL); // g01i: -0000123.456.789.012
   } // ganz01
   // ---------------------------------------------------------------------
   static void ganz02() {
      // Ein paar Ganzzahlen (posI und negI) werden mehrfach mit printf-
      // Befehlen und Formatstrings g02a, g02b, ... ausgegeben. Die
      // Soll-Ausgaben der printf-Befehle sind als Kommentar angegeben.
      // Wie muessen die Formatstrings aussehen, damit diese Soll-Ausgaben
      // entstehen?

      gibLinealAus("ganz02");

      // Ein paar Ganzzahlen:
      int posI = +167;
      int negI = -1;

      // Die printf-Befehle (und ihre Soll-Ausgabe als Kommentar):
                          //       1   5   10   15   20   25   30
                          //       |   |    |    |    |    |    |
      printf(g02a, posI); // g02a: a7
      printf(g02a, negI); // g02a: ffffffff
      printf(g02b, posI); // g02b: A7
      printf(g02b, negI); // g02b: FFFFFFFF
      printf(g02c, posI); // g02c: 0xa7
      printf(g02c, negI); // g02c: 0xffffffff
      printf(g02d, posI); // g02d: 0XA7
      printf(g02d, negI); // g02d: 0XFFFFFFFF
      printf(g02e, posI); // g02d: 0x000000a7
      printf(g02e, negI); // g02d: 0xffffffff
   } // ganz02
   // ---------------------------------------------------------------------
   static void bruch01() {
      // Ein paar Bruchzahlen (posI und negI) werden mehrfach mit printf-
      // Befehlen und Formatstrings b01a, b01b, ... ausgegeben. Die
      // Soll-Ausgaben der printf-Befehle sind als Kommentar angegeben.
      // Wie muessen die Formatstrings aussehen, damit diese Soll-Ausgaben
      // entstehen?

      gibLinealAus("bruch01");

      // Ein paar Bruchzahlen:
      double posD = +12345.678;
      double negD = -12345.678;

      // Die printf-Befehle (und ihre Soll-Ausgabe als Kommentar):
                          //       1   5   10   15   20   25   30
                          //       |   |    |    |    |    |    |
      printf(b01a, posD); // b01a: 12345,678000
      printf(b01a, negD); // b01a: -12345,678000
      printf(b01b, posD); // b01b: +12345,678
      printf(b01b, negD); // b01b: -12345,678
      printf(b01c, posD); // b01c:    +12345,68
      printf(b01c, negD); // b01c:    -12345,68
      printf(b01d, posD); // b01d:     12345,68
      printf(b01d, negD); // b01d:    -12345,68
   } // bruch01
   // ---------------------------------------------------------------------
   static void bruch02() {
      // Ein paar Bruchzahlen (posI und negI) werden mehrfach mit printf-
      // Befehlen und Formatstrings b02a, b02b, ... ausgegeben. Die
      // Soll-Ausgaben der printf-Befehle sind als Kommentar angegeben.
      // Wie muessen die Formatstrings aussehen, damit diese Soll-Ausgaben
      // entstehen?

      gibLinealAus("bruch02");

      // Ein paar Bruchzahlen:
      double posD = +12345678.901234;
      double negD = -12345678.901234;

      // Die printf-Befehle (und ihre Soll-Ausgabe als Kommentar):
                          //       1   5   10   15   20   25   30
                          //       |   |    |    |    |    |    |
      printf(b02a, posD); // b02a:  12.345.678,901234
      printf(b02a, negD); // b02a: -12.345.678,901234
      printf(b02b, posD); // b02b:       +12.345.678,90
      printf(b02b, negD); // b02b:       -12.345.678,90
      printf(b02c, posD); // b02c:    +12.345.678,90123
      printf(b02c, negD); // b02c:    -12.345.678,90123
      printf(b02d, posD); // b02d:           12.345.679
      printf(b02d, negD); // b02d:         (12.345.679)
   } // bruch02
   // ---------------------------------------------------------------------
   static void divers01() {

      gibLinealAus("divers01");

      // Diverse Variablen
      String  s01 = "Hallo!";
      String  s02 = null;
      boolean b01 = true;
      boolean b02 = false;
      Boolean b03 = new Boolean(true);
      Boolean b04 = new Boolean(false);
      JButton j01 = new JButton("Klick");

      // Die printf-Befehle (und ihre Soll-Ausgabe als Kommentar):
                              //       1   5   10   15   20   25   30
                              //       |   |    |    |    |    |    |
      printf(d01a, s01, s02); // d01a: Hallo!: true,   null:false
      printf(d01a, b01, b02); // d01a:   true: true,  false:false
      printf(d01a, b03, b04); // d01a:   true: true,  false:false
      printf(d01b, j01);      // d01b: javax.swing.JButton[,0,0,0x0,i ...

   } // divers01
   // ---------------------------------------------------------------------
   static void gibLinealAus(String name) {
      printf("---------------------------------%n");
      printf("Ausgabe der Methode %s:%n%n", name);
      printf("      1   5   10   15   20   25   30%n");
      printf("      |   |    |    |    |    |    |%n");
   } // gibLinealAus
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      printf("PrintfUeb01: Jetzt geht es los!%n");
      ganz01  ();
      ganz02  ();
      bruch01 ();
      bruch02 ();
      divers01();
      printf("---------------------------------%n");
      printf("Hex: %#x, Oct: %<#o, Dez: %<d%n", 16);
      printf("---------------------------------%n");
      printf("PrintfUeb01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Loesung fuer ganz01:
   static String g01a = "g01a Muss ersetzt werden%n";
   static String g01b = "g01b Muss ersetzt werden%n";
   static String g01c = "g01c Muss ersetzt werden%n";
   static String g01d = "g01d Muss ersetzt werden%n";
   static String g01e = "g01e Muss ersetzt werden%n";
   static String g01f = "g01f Muss ersetzt werden%n";
   static String g01g = "g01g Muss ersetzt werden%n";
   static String g01h = "g01h Muss ersetzt werden%n";
   static String g01i = "g01i Muss ersetzt werden%n";

   // Loesung fuer ganz02:
   static String g02a = "g02a Muss ersetzt werden%n";
   static String g02b = "g02b Muss ersetzt werden%n";
   static String g02c = "g02c Muss ersetzt werden%n";
   static String g02d = "g02d Muss ersetzt werden%n";
   static String g02e = "g02d Muss ersetzt werden%n";

   // Loesung fuer bruch01:
   static String b01a = "b01a Muss ersetzt werden%n";
   static String b01b = "b01b Muss ersetzt werden%n";
   static String b01c = "b01c Muss ersetzt werden%n";
   static String b01d = "b01d Muss ersetzt werden%n";

   // Loesung fuer bruch02:
   static String b02a = "b02a Muss ersetzt werden%n";
   static String b02b = "b02b Muss ersetzt werden%n";
   static String b02c = "b02c Muss ersetzt werden%n";
   static String b02d = "b02d Muss ersetzt werden%n";

   // Loesung fuer divers01:
   static String d01a = "d01a Muss ersetzt werden%n";
   static String d01b = "d01b Muss ersetzt werden%n";
   // ---------------------------------------------------------------------

   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class UebPrintf
/* ------------------------------------------------------------------------
Ausgabe des Programms UebPrintf

PrintfUeb01: Jetzt geht es los!
---------------------------------
Ausgabe der Methode ganz01:

      1   5   10   15   20   25   30
      |   |    |    |    |    |    |
g01a: 123456789012
g01a: -123456789012
g01b:  123456789012
g01b: -123456789012
g01c:         123456789012
g01c:        -123456789012
g01d: 00000000123456789012
g01d: -0000000123456789012
g01e:        +123456789012
g01e:        -123456789012
g01f:         123456789012
g01f:       (123456789012)
g01g:      123.456.789.012
g01g:     -123.456.789.012
g01h:     +123.456.789.012
g01h:     -123.456.789.012
g01i: 00000123.456.789.012
g01i: -0000123.456.789.012
---------------------------------
Ausgabe der Methode ganz02:

      1   5   10   15   20   25   30
      |   |    |    |    |    |    |
g02a: a7
g02a: ffffffff
g02b: A7
g02b: FFFFFFFF
g02c: 0xa7
g02c: 0xffffffff
g02d: 0XA7
g02d: 0XFFFFFFFF
g02d: 0x000000a7
g02d: 0xffffffff
---------------------------------
Ausgabe der Methode bruch01:

      1   5   10   15   20   25   30
      |   |    |    |    |    |    |
b01a: 12345,678000
b01a: -12345,678000
b01b: +12345,678
b01b: -12345,678
b01c:    +12345,68
b01c:    -12345,68
b01d:     12345,68
b01d:    -12345,68
---------------------------------
Ausgabe der Methode bruch02:

      1   5   10   15   20   25   30
      |   |    |    |    |    |    |
b02a:  12.345.678,901234
b02a: -12.345.678,901234
b02b:       +12.345.678,90
b02b:       -12.345.678,90
b02c:    +12.345.678,90123
b02c:    -12.345.678,90123
b02d:           12.345.679
b02d:         (12.345.679)
---------------------------------
Ausgabe der Methode divers01:

      1   5   10   15   20   25   30
      |   |    |    |    |    |    |
d01a: Hallo!: true,   null:false
d01a:   true: true,  false:false
d01a:   true: true,  false:false
d01b: javax.swing.JButton[,0,0,0x0,i ...
---------------------------------
PrintfUeb01: Das war's erstmal!
------------------------------------------------------------------------ */
